;********************************************************************************************************
;
;                                       MCS51-STC8 Specific code
;                                           keil C51 Compiler
;
; Filename : isr.A51
;统一管理中断
;********************************************************************************************************

$NOMOD51

;#include "isr.h"

EA  BIT     0A8H.7
SP  DATA    081H
B   DATA    0F0H
ACC DATA    0E0H
DPH DATA    083H
DPL DATA    082H
PSW DATA    0D0H
TH0 DATA    08CH
TL0 DATA    08AH
P2  DATA    0A0H
DPS DATA    0E3H
TA  DATA    0AEH
    
        NAME ISR_A    ;模块名
            
;声明引用全局变量和外部子程序
        EXTRN CODE  (_?OSIntEnter)
        EXTRN CODE  (_?OSIntExit)
            
            
            
;定义压栈出栈宏
PUSHALL    MACRO
        PUSH PSW
        PUSH ACC
        PUSH B
        PUSH DPL
        PUSH DPH
        PUSH AR0
        PUSH AR1
        PUSH AR2
        PUSH AR3
        PUSH AR4
        PUSH AR5
        PUSH AR6
        PUSH AR7
        ENDM
    
POPALL    MACRO
        POP  AR7
        POP  AR6
        POP  AR5
        POP  AR4
        POP  AR3
        POP  AR2
        POP  AR1
        POP  AR0
        POP  DPH
        POP  DPL
        POP  B
        POP  ACC
        POP  PSW
        ENDM
    
; **** 中断矢量区域 *************

; ==== 定时器1 中断服务程序 =============
        CSEG AT 001BH	;定时器T1中断
        LJMP Timer1_ISR
        
; ==== 定时器3 中断服务程序 =============
        CSEG AT 009BH	;定时器T3中断
        LJMP Timer3_ISR
        




; ==== 定时器1 中断服务程序 =============
;演示允许中断嵌套
EXTRN CODE  (_?Timer1_Handler)
Timer1_ISR:
        USING 0        ;工作寄存器0
        CLR EA  ;调用OSIntEnter之前先关中断
SETB 0A0H
        PUSHALL     ;现场保护
        LCALL _?OSIntEnter	;通知内核进入中断     
        SETB EA  ;允许中断嵌套
        
        LCALL _?Timer1_Handler
        
        LCALL _?OSIntExit   ;通知内核退出中断
        POPALL      ;恢复现场   
CLR 0A0H
        RETI
        
        
; ==== 定时器3 中断服务程序 =============
;演示禁止中断嵌套
EXTRN CODE  (_?Timer3_Handler)
Timer3_ISR:
        USING 0        ;工作寄存器0
SETB 0A6H;
        CLR EA      ;禁止中断嵌套
        PUSHALL     ;现场保护

        LCALL _?Timer3_Handler
        
        POPALL      ;恢复现场   
CLR    0A6H
        SETB  EA   ;中断函数执行完毕，重新允许中断
        RETI

;--------------------
END
;--------------------
